=== debian/changelog ===
golang-opentelemetry-proto (0.19.0-1) experimental; urgency=medium

  * Initial packaging (Closes: #1022829).

 -- Thomas Goirand <zigo@debian.org>  Thu, 06 Oct 2022 11:36:15 +0200
