=== debian/control ===
Source: golang-opentelemetry-proto
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
 Shengjing Zhu <zhsj@debian.org>,
Testsuite: autopkgtest-pkg-go
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 golang-any,
 golang-github-grpc-ecosystem-grpc-gateway.v2-dev,
 golang-google-grpc-dev (>= 1.38.0),
 golang-google-protobuf-dev,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-opentelemetry-proto
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-opentelemetry-proto.git
Homepage: https://github.com/open-telemetry/opentelemetry-proto-go
Rules-Requires-Root: no
XS-Go-Import-Path: go.opentelemetry.io/proto

Package: golang-opentelemetry-proto-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-grpc-ecosystem-grpc-gateway.v2-dev,
 golang-google-grpc-dev,
 golang-google-protobuf-dev,
 ${misc:Depends},
Description: OpenTelemetry Go API and SDK - proto
 OpenTelemetry-Go is the Go implementation of OpenTelemetry. It provides a set
 of APIs to directly measure performance and behavior of your software and send
 this data to observability platforms.
 .
 This package contains the proto module.
