=== debian/changelog ===
golang-opentelemetry-proto (1.3.1-2) unstable; urgency=medium

  * Team upload
  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 31 Oct 2024 06:14:13 -0400

golang-opentelemetry-proto (1.3.1-1) experimental; urgency=medium

  * Team upload
  * New upstream release: 1.3.1

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 20 Oct 2024 11:49:50 -0400

golang-opentelemetry-proto (0.19.0-2) unstable; urgency=medium

  * Team upload
  * Upload to unstable
  * d/control:
    - Update Build-Depends and Depends
    - Update Standards-Version to 4.7.0 (no changes needed)

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 25 Jul 2024 08:42:54 +0000
