=== debian/control ===
--- 
+++ 
@@ -10,10 +10,10 @@
  debhelper-compat (= 13),
  dh-golang,
  golang-any,
- golang-github-grpc-ecosystem-grpc-gateway.v2-dev,
- golang-google-grpc-dev (>= 1.38.0),
+ golang-github-grpc-ecosystem-grpc-gateway-dev (>= 2.20.0),
+ golang-google-grpc-dev (>= 1.64.0),
  golang-google-protobuf-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-opentelemetry-proto
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-opentelemetry-proto.git
 Homepage: https://github.com/open-telemetry/opentelemetry-proto-go
@@ -24,8 +24,8 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
- golang-github-grpc-ecosystem-grpc-gateway.v2-dev,
- golang-google-grpc-dev,
+ golang-github-grpc-ecosystem-grpc-gateway-dev (>= 2.20.0),
+ golang-google-grpc-dev (>= 1.64.0),
  golang-google-protobuf-dev,
  ${misc:Depends},
 Description: OpenTelemetry Go API and SDK - proto
